/* set_markdat(), set_traitdat(), set_probgam()               MAJ Aug/01   */

void  set_markdat (int ***yy, int nl, int nc)
{
   int   i, j, c, posp, cfound;

   for (i = 1; i <= NObs; ++i)
   {
      if ((posp = get_posit (IObs[i])) == INVALID_INDEX)
         give_warn (ERA_mdp, IObs[i]);

      else
         for (j = 1; j <= nl; ++j)
         {
            yy[0][j][posp] = Dat1[j][i];
            yy[1][j][posp] = Dat2[j][i];
         }
   }
   for (c = 0; c < nc; ++c)
   {
      cfound = 0;
      for (i = 1; i <= NObs; ++i)
         if ((posp = get_posit (IObs[i])) != INVALID_INDEX)
            if ((nghd[posp].component) == (c + 1))
               cfound = 1;
      if (!cfound)
         give_warn (ERA_nmd, c + 1);
   }
   return;
}

void  set_traitdat (int ***yy, int *qdex, int *trtphen, int pdsz, int nc)
{
   int   c, k, i, np, kfound, ifound;

   char *k_txt[5] =
   {
      "",
      "(homozygous normal) ",
      "(phenotypic normal for recessive trait, not implemented)",
      "(recessive carrier) ",
      "(recessive affected)"
   };

   printf ("\n\n Trait data:\n");

   for (c = 0; c < nc; ++c)
   {
      kfound = 0;
      printf ("\n Component %d:\n", c + 1);
      for (k = 4; k > 0; --k)           /* k=0 unknown        */
      {
         ifound = 0;
         np = 0;
         for (i = 0; i < pdsz; ++i)
         {
            if (nghd[i].component == c + 1 && data[i][5] == k)
               /*                        * k=0 unknown        */
            {
               if (TraitPheno)          /* ADDED CODE, EAT 9/00 & 10/00 */
               {
                  ++np;
                  qdex[i] = np;
                  trtphen[i] = data[i][5];
                  if (!kfound)
                     kfound = 1;
                  if (!ifound)
                     printf ("    phenotype %d %s:",
                             trtphen[i], k_txt[k]);
                  if (ifound && !(ifound % 8))
                     printf ("\n                                      ");
                  ++ifound;
                  printf (" %d", nghd[i].self);
               }
               else
               {
                  if (k == 2)           /* phenotypic normal for */
                     continue;          /* recessive trait not implemented */
                  if (k == 4)
                  {
                     yy[0][0][i] = 2;
                     yy[1][0][i] = 2;
                  }                     /* recessive affected */
                  if (k == 3)
                  {
                     yy[0][0][i] = 1;
                     yy[1][0][i] = 2;
                  }                     /* recessive carrier  */
                  if (k == 1)
                  {
                     yy[0][0][i] = 1;
                     yy[1][0][i] = 1;
                  }                     /*  homozyyg normal    */

                  if (k != 2)
                  {
                     if (!kfound)
                        kfound = 1;
                     if (!ifound)
                        printf ("    genotype %d %d %s:",
                                yy[0][0][i], yy[1][0][i], k_txt[k]);
                     if (ifound && !(ifound % 8))
                        printf ("\n                                      ");
                     ++ifound;
                     printf (" %d", nghd[i].self);
                  }
               }
            }
         }
         if (ifound)
            printf ("\n");
      }
      if (!kfound)
         printf ("    no trait data\n");
   }
   printf ("\n\n");
   fflush (stdout);

   return;
}

void  set_probgam (int nc)
{
   int   c, s, i, posp;

   for (c = 0; c < nc; ++c)
      if (NScCmp < c + 1)
         give_up (ERA_ncd, c + 1);

      else if (!NScSet[c])
         give_up (ERA_ncd, c + 1);

      else
         for (s = 0; s < NScSet[c]; ++s)
            for (i = 0; i < NPrGam[c][s]; ++i)
            {
               if ((posp = get_posit (Proband[c][s][i])) == INVALID_INDEX)
                  give_up (ERA_inp, Proband[c][s][i]);
               else if ((nghd[posp].component) != (c + 1))
                  give_up (ERA_pnc, Proband[c][s][i], c + 1,
                           nghd[posp].component);

               Proband[c][s][i] = posp;
            }
   if (NScCmp > nc)
      give_warn (ERA_mcd, NScCmp, nc);

   return;
}
