

/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*       autozyg.h:  header file for lm_auto.c & lm_lods.c             */
/*                    contains #includes for header files for          */
/*                        libraries used                               */
/*                    and #defines, typedefs, variables and            */
/*                        function prototypes for file lm_auto.c       */
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef AUTOZYG_H
#define AUTOZYG_H

#define DEFINE_DATA

#include "parsie.h"
#include "quant.h"
#include "nghds.h"
#include "pedchk.h"
#include "msample.h"
#include "lsample.h"
#include "rans.h"

struct _cleanup clean_auto[] = {
{"ugbmdpal",    free_fnams},
{"ugbmdpal",    freeChkPed},
{"ugbmdpal",    freeKey},
{"      al",    free_auto},
{"      al",    free_ped},
{"      al",    free_cmplists},
{"      al",    free_nghds},
{"      al",    free_allocate},
{"      al",    free_gen_dat},
{"      al",    free_switches},
{"       l",    free_marek},
{"      al",    locus_peel_free},
{"      al",    free_allocate_loci},
{"      al",    free_gen_pen},
{"      al",    free_logprob},
{"      al",    free_msmpl},
{"      al",    free_dub},
{""        ,    NULL}} ; 

void  allocz_y     (int ****pyy, int, int);
void  alloc_ibd    (int **, int ***, int ***, int ***, int **, double *****);
void  alloc_az_prob(int ***, int ****, double ***, double ***, double ***, 
                    double ***, double **);
void  free_y       (int ****, int);
void  free_ibd     (int **, int ***, int ***, int ***, int **, double *****);
void  free_az_prob (int ***, int ****, double ***, double ***, double ***, 
                    double ***, double **);
void set_markdat   (int ***, int, int);
void set_traitdat  (int ***, int *, int *, int, int);
void set_probgam   (int);

#endif /*AUTOZYG_H*/

