
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*      incs.h:  header file containing #includes:                     */
/*                    #include's for standard C headers used by        */
/*                        MORGAN main programs and function libraries  */
/*                    #include's for operating system specific headers */
/*                        (/sys, these may by non-portable)            */
/*                    #include's for MORGAN header files used by       */
/*                        all MORGAN libraries                         */
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef INCS_H
#define INCS_H 

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <float.h>
#include <limits.h>
#include <math.h>
#include <stddef.h>
#include <time.h>
#include <unistd.h>

#include <sys/times.h>
#include <sys/types.h>
#include <sys/param.h>

#ifdef SOLARIS 
#include <netdb.h>   /* (for MAXHOSTNAMLEN on SUN's) */
#endif 

#ifdef  DEFINE_DATA
#define GLOBAL
#else
#define GLOBAL extern
#endif  /*DEFINE_DATA*/

#include "limdefs.h"                            /*Macros for default    */
                                                /*min & max values      */
#include "globs.h"                              /*Global parameters     */
                                                /*initialized by Pars/  */
#include "errsprogs.h"                          /*Warning & error       */
                                                /*messages              */
#include "stuff.h"                              /*MORGAN utility        */
                                                /*functions             */
#endif  /*INCS_H*/

