
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*                 peelie.h:  header file for Peel/                    */
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef PEELIE_H
#define PEELIE_H

#include "incs.h"
#include "rans.h"

#define NV 6    /* bound on number of simultaneous variables +1 */
#define NS 60    /* max sibship + 1   */

#define N_GENOTYPE 10 /* # genotypes at 1 or 2 loci */
#define M_GENOTYPE 3  /* # genotypes at trait loci */

GLOBAL int *idatu; 
GLOBAL int *istore;
GLOBAL double **qstore; 
GLOBAL int *peelseq;     /* peeling sequence by index, transformed on entry */
                                /* added  EAT; March 1997 */

GLOBAL double * kstore;

GLOBAL int n_geno;              /* number of genotypes compound loci =10
                                    set to m_geno for single locus case  */
GLOBAL int m_geno;              /* number of genotypes at trait locus */

GLOBAL int mgiveng[N_GENOTYPE][M_GENOTYPE];
                                /* marker penetrance at 2-locus genotype */
                                /* alternative ditto -- Shili  */

#ifdef STUFF_COMMENTED_OUT

GLOBAL int h[MAX_SIZE];        /* marker phenotypes */

GLOBAL double trans[N_GENOTYPE][N_GENOTYPE][N_GENOTYPE];  /* segregation
                                        at 1 or 2 loci                   */
GLOBAL int mjrgene[N_GENOTYPE]; /* trait genotype of 2-locus compound genotype
                                        -- set to identity for 1 locus  */
GLOBAL double geno_freq[N_GENOTYPE];

#endif /* STUFF_COMMENTED_OUT */


GLOBAL double **mkpen;          /* marker penetrance -- Shili-- replaces 
                                                                mgiveng */
GLOBAL int *h;                  /* marker phenotypes */

GLOBAL double ***trans;         /* segregation at 1 or 2 loci             */
GLOBAL int *mjrgene;            /* trait genotype of 2-locus compound genotype
                                        -- set to identity for 1 locus  */
GLOBAL int *mkgeno;             /* marker genotype of 2-locus joint
                                        genotype kgeno                  */

GLOBAL double *geno_freq;  

void alloc_peel(int, int);
void free_peel(void);
void free_gauss(void);
double gauss_quant (double, double *, double, int);
double mjrpeel(double *, double *, int *, int, double, int);
double peel_quant(double, double *, int *, double, int);
double peel_quchk(double, double *, int *, int, int);
void peelseq_set(char *);
int peel_seq(char[], int);

#endif  /*PEELIE_H*/

