#include "lsample.h"

void  allocate_loci (int nl, int *nall, double **Qq)
{
   struct Locus *loc;
   int   i, *tp1;

   /* Allocate locus structures */
   if (!(loci = malloc (sizeof (struct Locus) * nl)))
            ALLOC_FAIL;
   if (!(tp1 = malloc (sizeof (int) * nl * (2 * pedsize + n_compnts))))
            ALLOC_FAIL;

   for (i = 0; i < nl; i++)
   {
      loc = loci + i;
      if ((i == 0) && (TraitPheno))         /* TRAIT LOCUS; locus 0; 
                                               pheno data */
      {
         loc->locus_type = TRAIT_LOCUS;
         loc->penetrance = recessive;
      }
      else
      {
         loc->locus_type = MARKER_LOCUS;
         loc->penetrance = 0;
      }

      loc->g_mu = 0;
      loc->index = i;
      loc->data_index = i;
      loc->n_all = nall[i];
      loc->n_alls = tp1;                    /* No. alleles per component */
      tp1 += n_compnts;
      loc->chromosome = 1;
      loc->malepos = loc->fempos = 0.0;
      loc->freq = Qq[i] + 1;
      loc->gt[0] = tp1;
      loc->gt[1] = tp1 + pedsize;
      tp1 += 2 * pedsize;
      /* Set up seg stuff */
      loc->seg[0] = xx0[i];
      loc->seg[1] = xx1[i];
      loc->genes[0] = gg0[i];
      loc->genes[1] = gg1[i];
   }
}

void  free_allocate_loci (void)
{
   if (loci)
   {
      if (loci[0].n_alls)
         free (loci[0].n_alls);
      free (loci);
      loci = NULL;
   }
}
