
#include "msample.h"

/* Routines to compute the forwards cumulative probabilities
   and then to do the revierse-peeling backwards computation */

void  fwd_compute (int j, double r, double *pen, double *prior, double *new)

/* at locus position j, given penetrances, and the priors to locus 
   position j-1 (prior),
   compute the probs to locus j (new), at recombination freq r  */

{
   if (j == 0)
   {
      new[0] = pen[0];
      new[1] = pen[1];
   }
   else
   {
      new[0] = pen[0] * (prior[0] * (1.0 - r) + prior[1] * r);
      new[1] = pen[1] * (prior[1] * (1.0 - r) + prior[0] * r);
   }

   new[0] = new[0] / (new[0] + new[1]);
   new[1] = 1.0 - new[0];

}

int   back_sample (int nloc, int j, int right, double r, double left_prob)

/* realise at locus position j, given realisation to the right, at
   recomb freq r, and cumulative penetrance to the left of left_prob 
   for value 0 */
{
   int   xx;
   double c0, c1;
   if (j == nloc)
   {
      if (rans () < left_prob)
         xx = 0;
      else
         xx = 1;
   }
   else
   {
      c0 = left_prob * ((1.0 - right) * (1.0 - r) + right * r);
      c1 = (1.0 - left_prob) * ((1.0 - right) * r + right * (1.0 - r));
      c0 = c0 / (c0 + c1);
      if (rans () < c0)
         xx = 0;
      else
         xx = 1;
   }

   return (xx);
}
