#include "msample.h"

/* routine to determine if individual is only child of a parent  */

int   only_kid (Ind * parent, Ind * child)
{
   int   ip, ic;
   Marlist *mlpt;
   Indlist *ilpt;

   ip = parent->self;
   ic = child->self;
   for (mlpt = parent->marriages; mlpt != NULL; mlpt = mlpt->next)
   {
      for (ilpt = mlpt->current->kids; ilpt != NULL; ilpt = ilpt->next)
         if ((ilpt->current->self) != ic)
            return (0);
   }
   return (1);
}

/* generate a list of the 2(pedsize-n_founder) switches (max), so can choose 
   a random switch  -- switch is indicated by individual and mat/pat.
   Also, set up a linked list of the switches in a given component for
   later use in sampling and scoring routines -- this bit added, EAT 11/2000 
   Also. move some switch variables to msample.h so do not have to be passed */

int   list_switches (int nl, int *nns)
{
   int   i, j, k, ns;
   Ind  *dad, *mum;
   Switchlist *iptr;

   meiosis = (Switch *) malloc ((MaxNsw + 1) * sizeof (Switch));
   alloc_chk (WHERE, meiosis);
   swchlist = (Switchcmp *) malloc ((n_compnts + 1) * sizeof (Switchcmp));
   alloc_chk (WHERE, swchlist);

   ns = 0;

   for (i = 0; i < pedsize; ++i)
   {
      if (nghd[i].pa->self != UNKNOWN)
      {
         dad = nghd[i].pa;
         mum = nghd[i].ma;

         if (((nghd[mum->index].ma->self) != UNKNOWN) ||
             (!(only_kid (mum, &nghd[i]))))
         {
            ++ns;
            meiosis[ns].ind = nghd[i];
            meiosis[ns].sex = 0;
         }
         else
            for (j = 0; j <= nl; ++j)
               xx0[j][i] = -1;

         if (((nghd[dad->index].pa->self) != UNKNOWN) ||
             (!(only_kid (dad, &nghd[i]))))
         {
            ++ns;
            meiosis[ns].ind = nghd[i];
            meiosis[ns].sex = 1;
         }
         else
            for (j = 0; j <= nl; ++j)
               xx1[j][i] = -1;
      }
   }
   /* now set up the linked list of meiosis switches by component */
   for (k = 1; k <= n_compnts; ++k)
   {
      nns[k] = 0;
      swchlist[k].index = k;
      swchlist[k].meioses = (Switchlist *) malloc (sizeof (Switchlist));
      alloc_chk (WHERE, swchlist[k].meioses);
      iptr = swchlist[k].meioses;
/*    iptr->current = (Switch *) malloc (sizeof (Switch));  MAJ 8/01   */
/*    alloc_chk (WHERE, iptr->current);                                */
      iptr->current = NULL;

      for (i = 1; i <= ns; ++i)
      {
         if (((meiosis[i].ind).component) == k)
         {
            iptr->next = (Switchlist *) malloc (sizeof (Switchlist));
            alloc_chk (WHERE, iptr->next);
            iptr = iptr->next;
            iptr->current = &meiosis[i];
            ++nns[k];
         }
      }
      iptr->next = NULL;
   }
/*
   printf ("\n list of switches");
   for (i = 1; i <= ns; ++i)
      printf ("\n %d %d %d %d", i,
      (meiosis[i].ind).index, (meiosis[i].ind).self, meiosis[i].sex);

   printf ("\n list of init segs");
   for (i = 0; i < pedsize; ++i)
   {
      printf ("\n %d %d;", nghd[i].index, nghd[i].self);
      for (j = 0; j <= nl; ++j)
      printf ("  %2d %2d", xx1[j][i], xx0[j][i]);
   }
   printf ("\n\n");
   fflush (stdout);
 */
   return (ns);
}

/* free the data structures for the switches   */

void  free_switches (void)
{
   int   k;
   Switchlist *p, *nxtp;

   if (!meiosis)
      return;

   free (meiosis);                          /* frees (Switch *) meiosis */
   meiosis = NULL;

   for (k = 1; k <= n_compnts; ++k)         /* frees (Switchlist *)  */
      for (p = swchlist[k].meioses; p; p = nxtp)
      {
         nxtp = p->next;
         free (p);
      }
   free (swchlist);                         /* frees (Switchcmp *) swchlist */
   swchlist = NULL;

   return;
}
