
#include "nghds.h"

/*
 * Recursive program which returns the kinship coefficient between
 * individuals a and b. 
 */

extern double inbreeding (Ind *);

double kinship (Ind * a, Ind * b)
{
   if (a == &nullnode || b == &nullnode)
      return 0.0;

   if (a == b)
      return 0.5 + 0.5 * inbreeding (a);
   else if (a->pa->self == 0)
   {
      if (b->index < a->index)
         return 0.0;
      else if (b->pa->self == 0)
         return 0.0;
      else
         return (kinship (a, b->pa) + kinship (a, b->ma)) * 0.5;
   }
   else if (b->pa->self == 0)
   {
      if (a->index < b->index)
         return 0.0;
      else
         return (kinship (b, a->pa) + kinship (b, a->ma)) * 0.5;
   }
   else if (a->index < b->index)
      return (kinship (a, b->pa) + kinship (a, b->ma)) * 0.5;
   else
      return (kinship (b, a->pa) + kinship (b, a->ma)) * 0.5;
}
