#include "nghds.h"

/*
 * Function to form a position submatrix consisting of two columns. 
 * The array is indexed by the individual's name. The first column is the
 * row index in the data matrix (or INVALID_INDEX if no such index exists),
 * and the second column is set to zero initially. Usually we just refer 
 * to the first namestring rows of this array where namestring is the 
 * largest name in the pedigree.
 * (Will be the indicator column for the neighbourhood system). 
 * e.g. pos[206][0] gives the row index of individual 206. 
 */
void  position (int **a, int **pos)
{
   int   i, j, name;

   for (i = 0; i <= namestring; i++)
   {
      pos[i][0] = INVALID_INDEX;
      pos[i][1] = 0;
   }
   for (j = 0; j < pedsize; j++)
   {
      name = a[j][1];
      if (name > namestring || name < 0)
         give_up_where (WHERE, ERN_nam, name);

      pos[name][0] = j;
   }
}
