
#include <stdio.h>
#include <math.h>

#define PNAM "kin"
#define DEFINE_DATA
#include "nghds.h"

int   main (int argc, char **argv)
{
   int   j = 0;                     /* counter */

   /* Following variables are used in reading the pedigree data */
   int   dodo_dim;
   int **dodo = NULL;
   double **quant = NULL;

   int   nfou;                      /* Number of founders */
   int   id1, id2;

   FILE *fopen (), *fp;

   print_head (*argv);

   MaxNames = MAX_NAMES;
   NColData = 7;
   MaxNCmps = 10;

   if (argc != 2)
   {
      printf ("Usage: kin input_file \n");
   }

   /* Open data file */
   if ((fp = fopen (argv[1], "r")) == NULL)
   {
      fprintf (stderr, "Can't open the data file.\n");
      perror ((char *) NULL);
      exit (1);
   }
   /* Read in data */
   fscanf (fp, "%d %d", &PedSize, &dodo_dim);  /* i and nt should be 0 */
   fscanf (fp, "%d %d", &NInts, &NTraits);
   printf ("\n pedsize =%d", PedSize);
   printf ("\n and ints and floats = %d %d \n", NInts, NTraits);
   fflush (stdout);

   for (j = 0; j < NInts; ++j)
   {
      SelInt[j] = j + 1;
   }
   alloc_ped ();
   input_ped (fp, 0, dodo, quant);

   nfou = count_founders ();
   printf ("\n # founders = %d", nfou);
   printf ("\n # components = %d\n\n", n_compnts);

   /* Calculating Kinship */
   fscanf (fp, "%d%d", &id1, &id2);
   printf ("The kinship coefficient between %d and %d is %f\n",
           id1, id2, kinship (nghd + posit[id1][0], nghd + posit[id2][0]));

   fscanf (fp, "%d%d", &id1, &id2);
   printf ("The kinship coefficient between %d and %d is %f\n",
           id1, id2, kinship (nghd + posit[id1][0], nghd + posit[id2][0]));

   /* Calculating Inbreeding coefficient */
   fscanf (fp, "%d", &id1);
   printf ("The inbreeding coefficient of %d is %f\n",
           id1, inbreeding (nghd + posit[id1][0]));

   fscanf (fp, "%d", &id1);
   printf ("The inbreeding coefficient of %d is %f\n",
           id1, inbreeding (nghd + posit[id1][0]));

   fclose (fp);

   return 0;
}
