#include "stuff.h"

/* If a morgan program starts with "atexit(clean_morg);", this function will
 * be called when the program quits.  
 * This function uses a table of main programs vs. freeing functions to call; 
 * the table structure is defined in stuff.h, but the contents must be defined 
 * in the main programs header (if defined in stuff.h, linking complications 
 * arise).
 */

void  clean_morg (void)
{
   static int entered = 0;
   struct _morgan *pm;
   struct _cleanup *pc;

   if (entered)                         /* cleanup (free memory) if not    */
      return;                           /* already done                    */
   entered = 1;
   /*                                    * get program code                */
   for (pm = morg_nam; pm->pnam[0] != NUL && strcmp (ProgNam, pm->pnam); ++pm)
      ;
   /*                                    * get cleanup functions           */
   for (pc = PCleanUp; pc->pcods[0] != NUL; ++pc)
      if (strchr (pc->pcods, pm->pcod))
         (pc->func) ();

   return;
}
